package com.fr.plugin.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;

@Visualization(category = "ipToken配置")
public class MySimpleConfig extends DefaultConfiguration {
    private static volatile MySimpleConfig config = null;

    public static MySimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(MySimpleConfig.class);
        }
        return config;
    }


    @Identifier(value = "openFilter", name = "是否启用拦截器", description = "", status = Status.SHOW)
    private Conf<Boolean> openFilter = Holders.simple(true);

    @Override
    public Object clone() throws CloneNotSupportedException {
        MySimpleConfig cloned = (MySimpleConfig) super.clone();
        cloned.openFilter = (Conf<Boolean>) openFilter.clone();
        return cloned;
    }
}
