package com.fr.plugin.http.ip;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONArray;
import com.fr.plugin.IPTokenPluginDecisionDBAccessProvider;
import com.fr.plugin.dao.UserIpRelationDao;
import com.fr.plugin.entity.UserIpEntity;
import com.fr.stable.StringUtils;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

public class ListApi extends BaseHttpHandler {
    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/ip/list";
    }

    @Override
    public boolean isPublic() {
        return false;
    }

    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse) throws Exception {
        DBAccessor dbAccessor = IPTokenPluginDecisionDBAccessProvider.getDbAccessor();
//        String userName = httpServletRequest.getParameter("userName");
//        int page = WebUtils.getHTTPRequestIntParameter(httpServletRequest, "page", 0);
        List<UserIpEntity> entityList = dbAccessor.runQueryAction(daoContext -> {
            QueryCondition queryCondition = QueryFactory.create();
//            if (StringUtils.isNotBlank(userName)) {
//                queryCondition.addRestriction(RestrictionFactory.eq("userName", userName));
//            }
//            queryCondition.setSkip(page * 10);
            List<UserIpEntity> entityList1 = daoContext.getDAO(UserIpRelationDao.class).find(queryCondition);
            return entityList1;
        });
        JSONArray jsonArray = JSONArray.create(entityList);
        WebUtils.printAsJSON(httpServletResponse, jsonArray);
    }
}
